var webpack = require('webpack')
var webpackDevMiddleware = require('webpack-dev-middleware')
var webpackHotMiddleware = require('webpack-hot-middleware')

var path = require('path');

function middleware(params, confDir) {
  var config = require(path.join(confDir, './webpack.dev.config'));

  try {

    var compiler = webpack(config);

    var confDir = confDir ||  pathLib.join(process.cwd(), ".config");

    var flexConfig = require(path.join(confDir, './flex-combo.json'));

    var devHanlder = webpackDevMiddleware(compiler, {
      publicPath: config.output.publicPath,
      stats: {colors: true}
    });

  } catch(e) {
    console.log(e);
    console.log(e.stack);
  }
  
  return function (req, res, next) {

    try {

      // 处理并且编译req.url呢
      // next执行时，包装再撤回req.url
      var originalUrl = req.url;
      for(var k in flexConfig.filter) {
        regx = new RegExp(k);

        if(regx.test(req.url)) {
            req.url = req.url.replace(regx, flexConfig.filter[k]);
        }

      }

      var nextWrapper = function () {
        req.url = originalUrl;
        next();
      }

      console.log('invoke this webpack clam1');

      devHanlder(req, res, nextWrapper);

    } catch(e) {
      console.log(e);
      console.log(e.stack);
    }
  }
}

module.exports = middleware;